<?php
/*
Plugin Name: Code Generator Pro
Plugin URI: http://walletstation.com/code-generator/
Description: Create code generators.
Version: 1.2
Author: WalletStation.com
Author URI: http://walletstation.com/
*/

global $code_generator_db_version;

$code_generator_db_version = '1.2';

function code_generator() {
	global $wpdb;
	
	global $code_generator_db_version;

	$code_generator_page_num = isset($_GET['page_num']) ? absint($_GET['page_num']) : 1;
	$code_generator_limit = 10;
	$code_generator_offset = ($code_generator_page_num - 1) * $code_generator_limit;
	
	$code_generator_get_generators = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."code_generator_generators ORDER BY id LIMIT $code_generator_offset, $code_generator_limit");
	
	$code_generator_total = $wpdb->get_var("SELECT COUNT(id) FROM ".$wpdb->prefix."code_generator_generators");
	$code_generator_num_of_pages = ceil($code_generator_total / $code_generator_limit);
	$code_generator_page_links = paginate_links( array(
		'base' => add_query_arg('page_num', '%#%'),
		'format' => '',
		'prev_text' => __('&laquo;', 'aag'),
		'next_text' => __('&raquo;', 'aag'),
		'total' => $code_generator_num_of_pages,
		'current' => $code_generator_page_num
	) );
?>
	<h2>Code Generator Pro <?php echo $code_generator_db_version; ?></h2>
	This plugin allows you to create code generators for Xbox Live codes, Amazon codes, Minecraft codes, etc. In order for a 
	user to obtain a code, they must go to a url, that your provide, to obtain a password. Once they obtain a password, they enter 
	it in the generator to get a code.
	<br /><br />
	<b>Features:</b><br />
	-Create unlimited generators.<br />
	-Create unlimited codes.<br />
	-Create unlimited URLs.<br />
	-URLs are randomized.<br />
	-Each generator has its own style.<br />
	-Generators can be added on posts or pages.<br />
	-Codes can only be accessed by one person at a time. A code becomes active once one of its URLs are accessed. If a password isn't entered, the code becomes non-active every hour.<br />
	-Once a password is entered, the code and its urls are deleted.
	<br /><br />
	<b>Donate:</b><br />
	Please <a href="http://walletstation.com/code-generator/">donate</a> to help support this plugin.
	<table cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td style="border-bottom: solid 1px #CCCCCC; padding: 5px" width="30%"><h2>Generators</h2></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="20%"><b>Display</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="10%"><b>Edit</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="10%"><b>Style</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="10%"><b>Code</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="10%"><b>Codes</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="10%"><b>Delete</b></td>
		</tr>
		<?php foreach($code_generator_get_generators as $code_generator_list_generators) : ?>
		<tr>
			<td style="border-bottom: solid 1px #CCCCCC; padding: 5px"><?php echo $code_generator_list_generators->name; ?></td>
			<td style="border-bottom: solid 1px #CCCCCC">[code_generator_display id ="<?php echo $code_generator_list_generators->id; ?>"]</td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('id', $code_generator_list_generators->id, 'admin.php?page=code_generator_edit_generator'); ?>">Edit</a></td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('id', $code_generator_list_generators->id, 'admin.php?page=code_generator_style'); ?>">Style</a></td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('id', $code_generator_list_generators->id, 'admin.php?page=code_generator_add_code'); ?>">Add</a></td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('id', $code_generator_list_generators->id, 'admin.php?page=code_generator_codes'); ?>">Codes</a></td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('del', $code_generator_list_generators->id, 'admin.php?page=code_generator_edit_generator&noheader=true'); ?>">Delete</a></td>
		</tr>
		<?php endforeach; ?>
	</table>
	
<?php 
	if($code_generator_page_links) {
		echo '<div class="tablenav"><div class="tablenav-pages" style="margin-right: 20px;">'.$code_generator_page_links.'</div></div>';
	}
	echo '</div>';
}

function code_generator_create_generator() {
	global $wpdb;
	
	if(isset($_POST['code_generator_create_generator_create'])) {
		$code_generator_create_generator_name = stripslashes((string)$_POST['code_generator_create_generator_name']);
		
		$wpdb->query("INSERT INTO ".$wpdb->prefix."code_generator_generators (name) VALUES ('$code_generator_create_generator_name')");

		@mkdir('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_create_generator_name.'/');
	    @chmod('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_create_generator_name.'/', 0777);
		$handle = @fopen('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_create_generator_name.'/'.$code_generator_create_generator_name.'.php', 'w');
		$data = file_get_contents('../wp-content/plugins/code-generator-pro/style.php');
		@fwrite($handle, $data);
		@fclose($handle);
		
		wp_redirect('admin.php?page=code_generator_generators');
        exit;
	}
?>
	<h2>Create Generator</h2>
    <form method="post" action="admin.php?page=code_generator_create_generator&noheader=true">
        <table width="300px">
        	<tr>
            	<td valign="middle"><strong>Name:</strong></td>
                <td><input name="code_generator_create_generator_name" type="text" size="40" /></td>
            </tr>
            <tr>
            	<td></td>
                <td> <div class="submit" style="padding: 0"><input type="submit" name="code_generator_create_generator_create" value="Create" /> </div></td>
            </tr>
        </table>
	</form>
<?php 
}

function code_generator_edit_generator() {
	global $wpdb;
	
	$code_generator_edit_generator_id = $_GET['id'];
	$code_generator_edit_generator_name = stripslashes((string)$_POST['code_generator_edit_generator_name']);

	if(isset($_POST['code_generator_edit_generator_edit'])) {
		$code_generator_edit_generator_old_name = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_edit_generator_id'");
		$wpdb->query("UPDATE ".$wpdb->prefix."code_generator_generators SET name = '$code_generator_edit_generator_name' WHERE id = '$code_generator_edit_generator_id'");
		$code_generator_edit_generator_new_name = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_edit_generator_id'");
		
		@rename('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_old_name->name.'/'.$code_generator_edit_generator_old_name->name.'.php', '../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_old_name->name.'/'.$code_generator_edit_generator_new_name->name.'.php');
		@rename('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_old_name->name, '../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_new_name->name);
	}
	
	if(isset($_GET['del'])) {
		$code_generator_edit_generator_del = $_GET['del'];
		$code_generator_edit_generator_del_name = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_edit_generator_id'");
		$code_generator_edit_generator_generator = $wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_edit_generator_del'");
		
		@unlink('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_del_name->name.'/'.$code_generator_edit_generator_del_name->name.'.php', 'w');
		@rmdir('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_edit_generator_del_name->name.'/');
		
		wp_redirect('admin.php?page=code_generator_generators');
        exit;
	}
	
	if(isset($_GET['id'])) {
		$code_generator_edit_generator_generator = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_edit_generator_id'");
	}
?>
	<h2>Edit Generator</h2>
    <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
        <table width="300px">
        	<tr>
            	<td valign="middle"><strong>Name:</strong></td>
                <td><input name="code_generator_edit_generator_name" type="text" size="40" value="<?php echo $code_generator_edit_generator_generator->name; ?>"/></td>
            </tr>
            <tr>
            	<td></td>
                <td><div class="submit" style="padding: 0"><input type="submit" name="code_generator_edit_generator_edit" value="Edit" /></div></td>
            </tr>
        </table>
	</form>
<?php 
}
function code_generator_style() {
	global $wpdb;
	
	$_POST = stripslashes_deep($_POST);
	
	$code_generator_style_generator_id = $_GET['id'];
	
	$code_generator_style_generator = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_generators WHERE id = '$code_generator_style_generator_id'");
	
	if(isset($_POST['code_generator_style_edit'])) {
		$code_generator_style_edit_cotent = $_POST['code_generator_style_content'];
		$handle = @fopen('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_style_generator->name.'/'.$code_generator_style_generator->name.'.php', 'w');
		fwrite($handle, $code_generator_style_edit_cotent);
		fclose($handle);
	}
	
	if(isset($_GET['id'])) {
		$code_generator_style_content = file_get_contents('../wp-content/plugins/code-generator-pro/themes/'.$code_generator_style_generator->name.'/'.$code_generator_style_generator->name.'.php');
	}
?>

	<h2>Edit <?php echo $code_generator_style_generator->name; ?></h2>
	<form name="template" id="template" action="<?php echo $_SERVER["REQUEST_URI"]; ?>" method="post">
		<div><textarea cols="70" rows="25" name="code_generator_style_content"><?php echo $code_generator_style_content; ?></textarea></div>
		<p class="submit"><input type="submit" name="code_generator_style_edit" value="Update File" /></p>
	</form>

<?php 
}
function code_generator_add_code() {
	global $wpdb;
	
	if( isset($_POST['code_generator_add_code_add'])) {
		$code_generator_add_code = stripslashes((string)$_POST['code_generator_add_code_code']);
		$code_generator_add_code_password = stripslashes((string)$_POST['code_generator_add_code_password']);
		$code_generator_add_code_urls = $_POST['code_generator_add_code_url'];
		$code_generator_add_code_parent_id = stripslashes((string)$_POST['code_generator_add_code_parent_id']);
		$wpdb->query("INSERT INTO ".$wpdb->prefix."code_generator_codes (parent_id,code,password,active) VALUES ('$code_generator_add_code_parent_id','$code_generator_add_code','$code_generator_add_code_password','0')");
		$code_generator_add_code_id = $wpdb->insert_id;

		foreach($code_generator_add_code_urls as $key => $value) :
			$code_generator_add_code_url[$key] = stripslashes($value);
			$wpdb->query("INSERT INTO ".$wpdb->prefix."code_generator_code_urls (code_id,url) VALUES ('$code_generator_add_code_id','$code_generator_add_code_url[$key]')");
		endforeach;
		
		wp_redirect('admin.php?page=code_generator_codes');
        exit;
	}
	
	if(isset($_GET['id'])){
		$code_generator_add_code_get_id = $_GET['id'];
	}
	
	$code_generator_add_code_get_generators = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."code_generator_generators");
?>
	<script>
	var i = 1;

	function addURL() {
		var tr = document.createElement('tr');
		tr.setAttribute("id", "code_generator_add_code_url_row_" + ++i);
		var td = tr.appendChild(document.createElement('td'));
		td.style.valign = 'middle';

		td = tr.appendChild(document.createElement('td'));
		var input = td.appendChild(document.createElement('input'));
		input.name = 'code_generator_add_code_url[]';
		input.type = 'text';
		input.size = '40'
		var node = document.getElementById('code_generator_add_code_table').tBodies[0];
		var add = document.getElementById('code_generator_add_code_url_add_row');
		node.insertBefore(tr, add);
	
		var link = document.createElement("a");
		link.setAttribute("href", ""); 
		link.setAttribute("style", "text-decoration: none;");
		link.setAttribute("onClick", "removeURL('code_generator_add_code_url_row_" + i + "');return false;");
		td = tr.appendChild(document.createElement('td'));
		td=td.appendChild(link)
		td.appendChild(document.createTextNode('-'));
	}

	function removeURL(code_generator_add_code_url_row_num) {
		var d = document.getElementById('code_generator_add_code_table').tBodies[0];
		var code_generator_add_code_remove_url_row = document.getElementById(code_generator_add_code_url_row_num);
		d.removeChild(code_generator_add_code_remove_url_row);
	}
	</script>
	<h2>Add Code</h2>
	Each code must have a unique password.
	<form method="post" action="admin.php?page=code_generator_add_code&noheader=true">
		<table id="code_generator_add_code_table" width="300px">
			<tbody>
				<tr id="code_generator_add_code_code_row">
					<td valign="middle"><strong>Code:</strong></td>
					<td><input name="code_generator_add_code_code" type="text" size="40" /></td>
				</tr>
				<tr id="code_generator_add_code_pw_row">
					<td valign="middle"><strong>Password:</strong></td>
					<td><input name="code_generator_add_code_password" type="text" size="40" /></td>
				</tr>
				<tr id="code_generator_add_code_url_row_1">
					<td valign="middle"><strong>URL:</strong></td>
					<td><input name="code_generator_add_code_url[]" type="text" size="40" /></td>
				</tr>
				<tr id="code_generator_add_code_url_add_row">
					<td></td>
					<td><a href="" style="text-decoration: none;" onClick="addURL('');return false;">+</a></td>
				</tr>
				<tr id="code_generator_add_code_generator_row">
					<td valign="middle"><strong>Generator:</strong></td>
					<td>
						<select name="code_generator_add_code_parent_id">
						<?php foreach($code_generator_add_code_get_generators as $code_generator_add_code_list_generators) : ?>
							<option value="<?php echo $code_generator_add_code_list_generators->id; ?>"<?php if($code_generator_add_code_list_generators->id == $code_generator_add_code_get_id) echo ' SELECTED'; ?>><?php echo $code_generator_add_code_list_generators->name; ?></option>
						<?php endforeach; ?>
						</select> 
					</td>
				</tr>
				<tr id="code_generator_add_code_add_row">
					<td></td>
					<td><div class="submit" style="padding: 0"><input type="submit" name="code_generator_add_code_add" value="Add" /> </div></td>
				</tr>
			</tbody>
        </table>
	</form>
<?php 
}

function code_generator_edit_code() {
	global $wpdb;
	
	$code_generator_edit_code_id = $_GET['id'];
	$code_generator_edit_code = stripslashes((string)$_POST['code_generator_edit_code']);
	$code_generator_edit_code_password = stripslashes((string)$_POST['code_generator_edit_code_password']);
	$code_generator_edit_code_urls = $_POST['code_generator_edit_code_url'];
	$code_generator_edit_code_new_urls = $_POST['code_generator_edit_code_new_url'];
	$code_generator_edit_code_parent_id = stripslashes((string)$_POST['code_generator_edit_code_parent_id']);
	$code_generator_edit_code_delete_id = $_GET['del'];
	$code_generator_edit_code_delete_url_id = $_GET['del_url'];

	if(isset($_POST['code_generator_edit_code_edit'])) {
		$wpdb->query("UPDATE ".$wpdb->prefix."code_generator_codes SET parent_id = '$code_generator_edit_code_parent_id',code = '$code_generator_edit_code',password = '$code_generator_edit_code_password',active = '0' WHERE id = '$code_generator_edit_code_id'");
		
		foreach($code_generator_edit_code_urls as $key => $value) :
			$code_generator_edit_code_url[$key] = stripslashes($value);
			$wpdb->query("UPDATE ".$wpdb->prefix."code_generator_code_urls SET code_id = '$code_generator_edit_code_id',url = '$code_generator_edit_code_url[$key]' WHERE url_id = '$key'");		
		endforeach;
		
		if(!empty($code_generator_edit_code_new_urls)) {
			foreach($code_generator_edit_code_new_urls as $key => $value) :
				$code_generator_edit_code_new_url[$key] = stripslashes($value);
				$wpdb->query("INSERT INTO ".$wpdb->prefix."code_generator_code_urls (code_id,url) VALUES ('$code_generator_edit_code_id','$code_generator_edit_code_new_url[$key]')");
			endforeach;
		}
	}
	
	if(isset($_GET['del'])) {
		$wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_code_urls WHERE code_id = '$code_generator_edit_code_delete_id'");
		$wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_codes WHERE id = '$code_generator_edit_code_delete_id'");
		wp_redirect('admin.php?page=code_generator_codes');
        exit;
	}

	if(isset($_GET['del_url'])) {
		$wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_code_urls WHERE url_id = '$code_generator_edit_code_delete_url_id'");
		wp_redirect('admin.php?page=code_generator_edit_code&id='.$code_generator_edit_code_id);
        exit;
	}
	
	if(isset($_GET['id'])) {
		$code_generator_edit_code_get_code = $wpdb->get_row("SELECT C.code, C.password, C.parent_id, U.url FROM ".$wpdb->prefix."code_generator_codes AS C LEFT JOIN ".$wpdb->prefix."code_generator_code_urls AS U ON C.id = U.url_id WHERE C.id = '$code_generator_edit_code_id'");
		$code_generator_edit_code_get_url = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."code_generator_code_urls WHERE code_id = '$code_generator_edit_code_id' ORDER BY url_id");
	}
	
	$code_generator_edit_code_get_generators = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."code_generator_generators");
?>
	<script>
	var number = 1;
	function addURL() {
		number++;
		var tr = document.createElement('tr');
		tr.setAttribute("id", "code_generator_edit_code_url_row_" + number);
		var td = tr.appendChild(document.createElement('td'));
		td.style.valign = 'middle';

		td = tr.appendChild(document.createElement('td'));
		var input = td.appendChild(document.createElement('input'));
		input.name = 'code_generator_edit_code_new_url[]';
		input.type = 'text';
		input.size = '40'
		var node = document.getElementById('code_generator_edit_code_table').tBodies[0];
		var add = document.getElementById('code_generator_edit_code_url_add_row');
		node.insertBefore(tr, add);
	
		var link = document.createElement("a");
		link.setAttribute("href", ""); 
		link.setAttribute("style", "text-decoration: none;");
		link.setAttribute("onClick", "removeURL('code_generator_edit_code_url_row_" + number +"');return false;");
		td = tr.appendChild(document.createElement('td'));
		td = td.appendChild(link)
		td.appendChild(document.createTextNode('-'));
	}

	function removeURL(code_generator_edit_code_url_row_num) {
		var d = document.getElementById('code_generator_edit_code_table').tBodies[0];
		var code_generator_edit_code_remove_url_row = document.getElementById(code_generator_edit_code_url_row_num);
		d.removeChild(code_generator_edit_code_remove_url_row);
	}

	function deleteURL(code_generator_edit_code_url_row_num,code_generator_edit_code_url_id) {
		var d = document.getElementById('code_generator_edit_code_table').tBodies[0];
		var code_generator_edit_code_remove_url_row = document.getElementById(code_generator_edit_code_url_row_num);
		d.removeChild(code_generator_edit_code_remove_url_row);
		window.location.href = window.location.href+'&noheader=true&del_url='+code_generator_edit_code_url_id;
	}
	</script>
	<h2>Edit Code</h2>
	Pressing - by the url text field will delete the url from the database.
    <form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
        <table id="code_generator_edit_code_table" width="300px">
        	<tr id="code_generator_edit_code_row">
            	<td valign="middle"><strong>Code:</strong></td>
                <td><input name="code_generator_edit_code" type="text" size="40" value="<?php echo $code_generator_edit_code_get_code->code; ?>" /></td>
            </tr>
         	<tr id="code_generator_edit_code_pw_row">
            	<td valign="middle"><strong>Password:</strong></td>
                <td><input name="code_generator_edit_code_password" type="text" size="40" value="<?php echo $code_generator_edit_code_get_code->password; ?>"  /></td>
            </tr>
			<?php $code_generator_edit_code_url_number=1; foreach($code_generator_edit_code_get_url as $code_generator_edit_code_list_url) : ?>
			<?php if($code_generator_edit_code_list_url === reset($code_generator_edit_code_get_url)) { ?>
         	<tr id="code_generator_edit_code_url_row_1">
            	<td valign="middle"><strong>URL:</strong></td>
                <td><input name="code_generator_edit_code_url[<?php echo $code_generator_edit_code_list_url->url_id; ?>]" id="<?php echo $code_generator_edit_code_list_url->url_id; ?>" type="text" size="40" value="<?php echo $code_generator_edit_code_list_url->url; ?>"  /></td>
			</tr>
			<?php } else { ?>
         	<tr id="code_generator_edit_code_url_row_<?php $code_generator_edit_code_url_number++; echo $code_generator_edit_code_url_number; ?>">
            	<td valign="middle"></td>
                <td><input name="code_generator_edit_code_url[<?php echo $code_generator_edit_code_list_url->url_id; ?>]" type="text" size="40" value="<?php echo $code_generator_edit_code_list_url->url; ?>"  /></td>
				<td><a href="" style="text-decoration: none;" onClick="deleteURL('<?php echo "code_generator_edit_code_url_row_".$code_generator_edit_code_url_number; ?>','<?php echo $code_generator_edit_code_list_url->url_id; ?>');return false;">-</a></td>
			</tr>			
			<?php } endforeach; ?>
			<tr id="code_generator_edit_code_url_add_row">
				<td></td>
				<td><a href="" style="text-decoration: none;" onClick="addURL('');return false;">+</a></td>
			</tr>
         	<tr id="code_generator_edit_code_generator_row">
            	<td valign="middle"><strong>Generator:</strong></td>
                <td>
				<select name="code_generator_edit_code_parent_id">
				<?php foreach($code_generator_edit_code_get_generators as $code_generator_edit_code_list_generators) : ?>
				<option value="<?php echo $code_generator_edit_code_list_generators->id; ?>"<?php if($code_generator_edit_code_list_generators->id == $code_generator_edit_code_get_code->parent_id) echo ' SELECTED'; ?>><?php echo $code_generator_edit_code_list_generators->name; ?></option>
				<?php endforeach; ?>
				</select> 
				</td>
            </tr>
			<tr id="code_generator_edit_code_edit_row">
            	<td></td>
                <td> <div class="submit" style="padding: 0"><input type="submit" name="code_generator_edit_code_edit" value="Edit" /> </div></td>
            </tr>
        </table>
	</form>
<?php 
}

function code_generator_codes() {
	global $wpdb;
	
	$code_generator_codes_page_num = isset($_GET['page_num']) ? absint($_GET['page_num']) : 1;
	$code_generator_codes_limit = 10;
	$code_generator_codes_offset = ($code_generator_codes_page_num - 1) * $code_generator_codes_limit;
	
	
	if(isset($_GET['id'])) {
		$code_generator_codes_id = $_GET['id'];
		$code_generator_codes_get_codes = $wpdb->get_results("SELECT C.code, C.id, C.active, G.name FROM ".$wpdb->prefix."code_generator_codes AS C LEFT JOIN ".$wpdb->prefix."code_generator_generators AS G ON C.parent_id = G.id WHERE C.parent_id = $code_generator_codes_id ORDER BY C.id LIMIT $code_generator_codes_offset, $code_generator_codes_limit");
		$code_generator_codes_name = $wpdb->get_row("SELECT G.name FROM ".$wpdb->prefix."code_generator_codes AS C LEFT JOIN ".$wpdb->prefix."code_generator_generators AS G ON C.parent_id = G.id WHERE C.parent_id = $code_generator_codes_id");
	}
	else {
		$code_generator_codes_get_codes = $wpdb->get_results("SELECT C.code, C.id, C.active, G.name FROM ".$wpdb->prefix."code_generator_codes AS C LEFT JOIN ".$wpdb->prefix."code_generator_generators AS G ON C.parent_id = G.id ORDER BY C.id LIMIT $code_generator_codes_offset, $code_generator_codes_limit");
	}
	
	$code_generator_codes_total = $wpdb->get_var("SELECT COUNT(id) FROM ".$wpdb->prefix."code_generator_codes");
	$code_generator_codes_num_of_pages = ceil($code_generator_codes_total / $code_generator_codes_limit);
	$code_generator_codes_page_links = paginate_links(array(
		'base' => add_query_arg('page_num', '%#%'),
		'format' => '',
		'prev_text' => __('&laquo;', 'aag'),
		'next_text' => __('&raquo;', 'aag'),
		'total' => $code_generator_codes_num_of_pages,
		'current' => $code_generator_codes_page_num
	) );
?>
	<h2><?php echo $code_generator_codes_name->name; ?> Codes</h2>
	<table cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td style="border-bottom: solid 1px #CCCCCC; padding: 5px" width="300"><h2>Codes</h2></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="100"><b>Generator</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="100"><b>Active</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="100"><b>Edit</b></td>
			<td style="border-bottom: solid 1px #CCCCCC" width="100"><b>Delete</b></td>
		</tr>
		<?php foreach($code_generator_codes_get_codes as $code_generator_codes_list_codes) : ?>
		<tr>
			<td style="border-bottom: solid 1px #CCCCCC; padding: 5px"><?php echo $code_generator_codes_list_codes->code; ?></td>
			<td style="border-bottom: solid 1px #CCCCCC"><?php echo $code_generator_codes_list_codes->name; ?></div>
			<td style="border-bottom: solid 1px #CCCCCC">
			<?php 
			$code_generator_codes_active = $code_generator_codes_list_codes->active;
			if($code_generator_codes_active == '0') {
			echo "No";
			}
			else {
			echo "Yes";
			}
			?>
			</td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('id', $code_generator_codes_list_codes->id, 'admin.php?page=code_generator_edit_code'); ?>">Edit</a></td>
			<td style="border-bottom: solid 1px #CCCCCC"><a href="<?php echo add_query_arg('del', $code_generator_codes_list_codes->id, 'admin.php?page=code_generator_edit_code&noheader=true'); ?>">Delete</a></td>
		</tr>
		<?php endforeach; ?>
	</table>
<?php
	if($code_generator_codes_page_links) {
		echo '<div class="tablenav"><div class="tablenav-pages" style="margin-right: 20px;">'.$code_generator_codes_page_links.'</div></div>';
	}
	echo '</div>';

}

function code_generator_display($atts) {
	extract(shortcode_atts(array(
		'id' => ''
	), $atts ) );
	
	global $wpdb, $code_generator_generate_code;
	
	$code_generator_display_get_codes = $wpdb->get_results("SELECT C.active, C.id AS code_id, G.id AS generator_id, G.name FROM ".$wpdb->prefix."code_generator_generators AS G LEFT OUTER JOIN ".$wpdb->prefix."code_generator_codes AS C ON G.id = C.parent_id WHERE G.id = '$id'");
	
	foreach($code_generator_display_get_codes as $code_generator_display_codes) :
		$code_generator_display_codes_generator_name = $code_generator_display_codes->name;
		$code_generator_display_codes_generator_id = $code_generator_display_codes->generator_id;
		$code_generator_display_codes_code_id = $code_generator_display_codes->code_id;
		$code_generator_display_codes_active = $code_generator_display_codes->active;
		
		if($code_generator_display_codes_active == "0") {
			$code_generator_display_url[] = get_bloginfo('url')."?g=".$code_generator_display_codes_generator_id."&c=".$code_generator_display_codes_code_id;
		}
	endforeach;
	
	$code_generator_display_num_codes = $wpdb->get_var("SELECT COUNT(id) FROM ".$wpdb->prefix."code_generator_codes WHERE parent_id = $id");

	$code_generator_display_path = WP_PLUGIN_DIR.'/code-generator-pro/themes/'.$code_generator_display_codes_generator_name.'/'.$code_generator_display_codes_generator_name.'.php';
	
	include_once($code_generator_display_path);
}

add_shortcode('code_generator_display', 'code_generator_display');

function code_generator_generate() {

	global $wpdb, $code_generator_generate_code;

	if(isset($_POST['code_generator_generate_generate'])){
		$code_generator_generate_password = stripslashes((string)$_POST['code_generator_generate_password']);
		
		$code_generator_generate_generator_id = stripslashes((string)$_POST['code_generator_generate_generator_id']);
		
		$code_generator_generate_code = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."code_generator_codes WHERE password = '$code_generator_generate_password' AND parent_id = '$code_generator_generate_generator_id'");
		
		$code_generator_generate_code_id = $code_generator_generate_code->id;
		
		$wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_code_urls WHERE code_id = '$code_generator_generate_code_id'");
		
		$wpdb->get_row("DELETE FROM ".$wpdb->prefix."code_generator_codes WHERE password = '$code_generator_generate_password' AND parent_id = '$code_generator_generate_generator_id'");
	}
	
	if(isset($_GET['g']) && isset($_GET['c'])){
		$code_generator_generate_generator_id = $_GET['g'];
		
		$code_generator_generate_code_id = $_GET['c'];

		$code_generator_generate_get_urls = $wpdb->get_results("SELECT U.url FROM ".$wpdb->prefix."code_generator_code_urls AS U LEFT JOIN ".$wpdb->prefix."code_generator_codes AS C ON U.code_id = C.id LEFT JOIN ".$wpdb->prefix."code_generator_generators AS G ON C.parent_id = G.id WHERE G.id = '$code_generator_generate_generator_id' AND U.code_id = '$code_generator_generate_code_id' AND C.active = '0'");

		$wpdb->query("UPDATE ".$wpdb->prefix."code_generator_codes SET active = '1' WHERE id = '$code_generator_generate_code_id'");
		
		foreach($code_generator_generate_get_urls as $code_generator_generate_get_url):
			$code_generator_generate_url[] = $code_generator_generate_get_url->url;
		endforeach;

		$code_generator_generate_urls = $code_generator_generate_url[array_rand($code_generator_generate_url)];
		
		wp_redirect($code_generator_generate_urls);
        exit;
	}
}

function code_generator_setup() {
	global $wpdb;
	
	global $code_generator_db_version;

	$wpdb->query("CREATE TABLE ".$wpdb->prefix."code_generator_generators (id SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, name VARCHAR(40) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL) ENGINE = MYISAM;");
	$wpdb->query("CREATE TABLE ".$wpdb->prefix."code_generator_codes (id SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, parent_id SMALLINT UNSIGNED NOT NULL, code VARCHAR(40) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL, password VARCHAR(40) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL, active TINYINT NOT NULL) ENGINE = MYISAM;");
	$wpdb->query("CREATE TABLE ".$wpdb->prefix."code_generator_code_urls (url_id SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, code_id SMALLINT UNSIGNED NOT NULL, url VARCHAR(80) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL) ENGINE = MYISAM;");

	add_menu_page('Code Generator', 'Code Generator', 8, 'code_generator_generators', 'code_generator');
	add_submenu_page('code_generator_generators', 'Create Generator', 'Create Generator', 8, 'code_generator_create_generator', 'code_generator_create_generator');
	add_submenu_page('code_generator_generators', 'Add Code', 'Add Code', 8, 'code_generator_add_code', 'code_generator_add_code');
	add_submenu_page('code_generator_generators', 'Codes', 'Codes', 8, 'code_generator_codes', 'code_generator_codes');
	add_submenu_page('code_generator_generators', 'Edit Generator', '', 8, 'code_generator_edit_generator', 'code_generator_edit_generator');
	add_submenu_page('code_generator_generators', 'Generator Style', '', 8, 'code_generator_style', 'code_generator_style');
	add_submenu_page('code_generator_generators', 'Edit Code', '', 8, 'code_generator_edit_code', 'code_generator_edit_code');
	
	$code_generator_installed_ver = get_option("code_generator_db_version");
	
	$table_name = $wpdb->prefix . "code_generator_code_urls";

	if($code_generator_installed_ver != $code_generator_db_version) {
		$sql = "CREATE TABLE $table_name (
		url_id SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, 
		code_id SMALLINT UNSIGNED NOT NULL,
		url VARCHAR(80) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL
		);";
		
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
		add_option("code_generator_db_version", $code_generator_db_version);
	}
}

function code_generator_update_db_check() {
    global $code_generator_db_version;
	
	if (get_site_option('code_generator_db_version') != $code_generator_db_version) {
        code_generator_setup();
    }
}
add_action('code_generator_loaded', 'code_generator_update_db_check');

register_activation_hook(__FILE__, 'code_generator_code_active');
add_action('code_generator_code_active_change', 'code_generator_code_active_zero');

function code_generator_code_active() {
	wp_schedule_event(time(), 'hourly', 'code_generator_code_active_change');
}

function code_generator_code_active_zero() {
	global $wpdb;
	
	$wpdb->query("UPDATE ".$wpdb->prefix."code_generator_codes SET active = '0'");
}

register_deactivation_hook(__FILE__, 'code_generator_code_active_deactivation');

function code_generator_code_active_deactivation() {
	wp_clear_scheduled_hook('code_generator_code_active_change');
}

add_action('admin_menu', 'code_generator_setup'); 
add_action('init','code_generator_generate');
?>